{****************************************
**  TmsEndlessProgressBar version 1.1  **
**        (c) 2007-2009 MarcaSoft      **
****************************************}

unit msEndlessProgressBar;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type
  TmsEndlessProgressBar = class(TCustomPanel)
  private
    { Private declarations }
    ProgSeg: array[0..30] of tshape;
    fSegCount: integer; //number of segments that are showing;
    fSegIndex: integer; //progress bar's current position;
    fSegColor: tColor;
    fBarColor: tColor;
    fEnabled: boolean;
    procedure setsize(segcount: integer);
    procedure setBarColor(aColor: tcolor);
    procedure setSegColor(aColor: tcolor);
  protected
    { Protected declarations }
    procedure resize; override;
    property ParentBackGround;
  public
    { Public declarations }
    constructor
      Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Reset;
      procedure StepIt;
  published
    { Published declarations }
    property BarColor: tColor
    read fBarColor write setBarColor default clBtnFace;
    property SegColor: tColor
    read fSegColor write setSegColor default clActiveCaption;
    property Enabled: boolean
    read fEnabled write fEnabled default false;
    property Align;
    property Cursor;
    property DragCursor;
    property DragMode;
    property Height;
    property Helpcontext;
    property Hint;
    property Left;
    property Name;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Tag;
    property Top;
    property Visible;
    property Width;
    property OnMouseDown;
    property OnMouseUp;
    property OnMouseMove;
end;

procedure Register;

implementation

constructor
  TmsEndlessProgressBar.Create(AOwner: TComponent);
var
  x: integer;
begin
  inherited Create(AOwner);
  controlstyle:=controlstyle-[csAcceptsControls];
  fSegCount:=-1;
  fSegindex:=0;
  bevelouter:=bvlowered;
  height:=17;
  width:=150;
  parentbackground:=false;
  parentcolor:=false;
  fEnabled:=false;
  fBarColor:=clBtnFace;
  fSegColor:=clActiveCaption;
  if not (csdesigning in componentstate) then begin
    for x:= 0 to 30 do begin
      ProgSeg[x]:=tShape.create(self);
      ProgSeg[x].parent:=self;
      ProgSeg[x].brush.color:=fSegColor;
      progSeg[x].pen.color:=fBarColor;
      ProgSeg[x].pen.width:=1;
      setsize(x);
    end;
    caption:='';
  end;
end;

destructor TmsEndlessProgressBar.destroy;
var
  x: integer;
begin
  for x:=0 to 30 do begin
    ProgSeg[x].free;
  end;
  inherited Destroy;
end;

procedure TmsEndlessProgressBar.Reset;
var
  x: integer;
begin
  for x:=0 to 30 do begin
    ProgSeg[x].visible:=false;
  end;
  fSegIndex:=0;
end;

procedure TmsEndlessProgressBar.setBarColor(aColor: tcolor);
var
  x: integer;
begin
  if not (csdesigning in componentstate) then begin
    for x:= 0 to 30 do begin
      ProgSeg[x].pen.color:=aColor;
    end;
  end;
  self.color:=acolor;
  fBarColor:=acolor;
end;

procedure TmsEndlessProgressBar.setSegColor(aColor: tcolor);
var
  x: integer;
begin
  if not (csdesigning in componentstate) then begin
    for x:= 0 to 30 do begin
      ProgSeg[x].brush.color:=aColor;
    end;
  end;
  fSegColor:=acolor;
end;

procedure TmsEndlessProgressBar.setsize(segcount: integer);
begin
  ProgSeg[segcount].width:=self.width div 30+1;
  ProgSeg[segcount].height:=self.height-self.bevelwidth*2;
  ProgSeg[segcount].top:=self.bevelwidth;
  ProgSeg[segcount].visible:=false;
  if ProgSeg[segcount].width<10 then
    ProgSeg[segcount].width:=10;
  ProgSeg[segcount].left:=ProgSeg[segcount].width*segcount+1;
  If ProgSeg[segcount].left+ProgSeg[segcount].width+1>self.width-self.BevelWidth then begin
    ProgSeg[segcount].width:=self.width-self.BevelWidth-ProgSeg[segcount].left-1;
    if fSegCount=-1 then begin
        fSegCount:=segcount+1;
    end else begin
    end;
  end;
  if (segcount=30)
  and (fSegCount=-1) then
    fSegCount:=31;
end;

procedure TmsEndlessProgressBar.resize;
var
  x: integer;
begin
  inherited resize;
    if not (csdesigning in componentstate) then begin
    fSegCount:=-1;
    for x:= 0 to 30 do begin
      setsize(x);
      ProgSeg[x].visible:=false;
    end;
  end;
end;

procedure TmsEndlessProgressBar.StepIt;
begin
  if fEnabled then begin
    if (fSegIndex-3>-1)
    and (fSegIndex-3<fSegCount) then
      ProgSeg[fSegIndex-3].visible:=false;
    if (fSegIndex-2>-1)
    and (fSegIndex-2<fSegCount) then
      ProgSeg[fSegIndex-2].visible:=true;
    if (fSegIndex-1>-1)
    and (fSegIndex-1<fSegCount) then
      ProgSeg[fSegIndex-1].visible:=true;
    if (fSegIndex>-1)
    and (fSegIndex<fSegCount) then
      ProgSeg[fSegIndex].visible:=true;
    fSegIndex:=fSegIndex+1;
    if fSegIndex>fSegCount+2 then
      fSegIndex:=0;
  end;
end;

procedure Register;
begin
  RegisterComponents('MarcaSoft', [TmsEndlessProgressBar]);
end;

end.
